# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Functions

* [`ldapquery`](#ldapquery): DEPRECATED.  Use the namespaced function [`ldapquery::query`](#ldapqueryquery) instead.
* [`ldapquery::query`](#ldapquery--query): Provides a query interface to an LDAP server

## Functions

### <a name="ldapquery"></a>`ldapquery`

Type: Ruby 4.x API

DEPRECATED.  Use the namespaced function [`ldapquery::query`](#ldapqueryquery) instead.

#### `ldapquery(Any *$args)`

The ldapquery function.

Returns: `Any`

##### `*args`

Data type: `Any`



### <a name="ldapquery--query"></a>`ldapquery::query`

Type: Ruby 4.x API

Provides a query interface to an LDAP server

#### Examples

##### Simple query

```puppet
ldapquery::query("(objectClass=dnsDomain)", ['dc'])
```

##### More complex query for ssh public keys

```puppet
ldapquery::query('(&(objectClass=ldapPublicKey)(sshPublicKey=*)(objectClass=posixAccount))', ['uid', 'sshPublicKey'])
```

#### `ldapquery::query(String[1] $filter, Optional[Array[String[1]]] $attributes, Optional[Options] $options)`

The ldapquery::query function.

Returns: `Any`

##### Examples

###### Simple query

```puppet
ldapquery::query("(objectClass=dnsDomain)", ['dc'])
```

###### More complex query for ssh public keys

```puppet
ldapquery::query('(&(objectClass=ldapPublicKey)(sshPublicKey=*)(objectClass=posixAccount))', ['uid', 'sshPublicKey'])
```

##### `filter`

Data type: `String[1]`

The filter you want to query the LDAP server with

##### `attributes`

Data type: `Optional[Array[String[1]]]`

Which attributes you want to query

##### `options`

Data type: `Optional[Options]`

Function options where you can specify `base`, `scope`, and `server`.

